


local assets =
{
	Asset("ANIM", "anim/blunderbuss.zip"),
	Asset("ANIM", "anim/swap_blunderbuss.zip"),
    Asset("ANIM", "anim/swap_blunderbuss_loaded.zip"),
    Asset("ANIM", "anim/blunderbuss_ammo.zip"),

    Asset("INV_IMAGE", "blunderbuss"),
    Asset("INV_IMAGE", "blunderbuss_loaded"),
	
	Asset("ANIM", "anim/ui_sg_1x1_4.zip"), 
}

local function onequip(inst, owner, force)
    owner.AnimState:OverrideSymbol("swap_object", inst.override_bank, "swap_blunderbuss")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal") 
	inst.components.container:Open(owner)
end

local function onunequip(inst,owner) 
    owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
	inst.components.container:Close(owner)
end





local function onload(inst, data,owner)



if GetPlayer().components.inventory:IsItemEquipped(inst) then
inst.components.container:Open(owner)
end

end

local function onsave(inst, data)


end


 

-- local function CanTakeAmmo(inst, ammo, giver)
    -- return ammo.prefab == "gunpowder"
-- end

-- local function OnTakeAmmo(inst, data)
    -- local ammo = data and data.item
    -- if not ammo then return end

    -- inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/items/weapon/blunderbuss_load")

    
    -- Set up as projectile thrower instead of crummy bat
    -- inst:AddTag("projectile")
    -- inst.components.weapon:SetProjectile("gunpowder_projectile")
    -- inst:AddTag("blunderbuss")

    -- Change ranges
    -- inst.components.weapon:SetRange(TUNING.BLUNDERBUSS_ATTACK_RANGE, TUNING.BLUNDERBUSS_HIT_RANGE)
    -- local damage = TUNING.GUNPOWDER_DAMAGE
    -- inst.components.weapon:SetDamage(damage)

    -- inst.override_bank = "swap_blunderbuss_loaded"

    -- If equipped, change current equip overrides
    -- if inst.components.equippable and inst.components.equippable:IsEquipped() then
        -- local owner = inst.components.equippable.equipper
        -- owner.AnimState:OverrideSymbol("swap_object", inst.override_bank, "swap_blunderbuss")
    -- end

    -- Change invo image.
    -- inst.components.inventoryitem:ChangeImageName("blunderbuss_loaded")
-- end

-- local function OnLoseAmmo(inst, data)
    -- Go back to crummy bat mode
    -- inst:RemoveTag("projectile")
    -- inst.components.weapon:SetProjectile(nil)
    -- inst:RemoveTag("blunderbuss")

    -- Change ranges back to melee
    -- inst.components.weapon:SetRange(nil, nil)
    -- inst.components.weapon:SetDamage(TUNING.UNARMED_DAMAGE)

    -- Change equip overrides
    -- inst.override_bank = "swap_blunderbuss"

    -- If equipped, change current equip overrides
    -- if inst.components.equippable and inst.components.equippable:IsEquipped() then
        -- local owner = inst.components.equippable.equipper
        -- owner.AnimState:OverrideSymbol("swap_object", inst.override_bank, "swap_blunderbuss")
    -- end

    -- inst.components.inventoryitem:ChangeImageName("blunderbuss")
-- end
local function CanAttack(inst, target)
    -- if inst.components.container:IsFull() and TheInput:IsMouseDown(MOUSEBUTTON_RIGHT) then
       -- inst.components.weapon:LaunchProjectile(inst, target)
    -- end
     if inst.components.container:IsFull()then
       return true
    end
end


local function OnAttack(inst, attacker, target)
    inst.components.container:ConsumeByName("gunpowder", 1)
    
end

local function OnFinished(inst)
    inst:Remove()
end

local slotpos = {}

	table.insert(slotpos, Vector3(-123, 10 ,0))

local function itemtest(inst, item, slot)
	return item.prefab == "gunpowder"
end

local function fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()

    MakeInventoryPhysics(inst)
    inst:AddTag("blunderbus")

    anim:SetBank("blunderbuss")
    anim:SetBuild("blunderbuss")
    anim:PlayAnimation("idle")

    inst:AddComponent("inspectable")

    inst:AddComponent("weapon")
    inst.components.weapon.onattack = OnAttack
	--inst.components.weapon:SetCanAttack(CanAttack)

    inst:AddComponent("inventoryitem")

    inst:AddComponent("container")
	inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_2x4"
    inst.components.container.widgetanimbuild = "ui_sg_1x1_4"
    inst.components.container.widgetpos = Vector3(-150,-300,0)
	inst.components.container.widgetpos_controller = Vector3(-150,-300,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "magazine"
	
	inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    MakeInventoryFloatable(inst, "idle_water", "idle")
    inst.override_bank = "swap_blunderbuss"
	
    inst:DoPeriodicTask(0.1, function()
	
	if not GetPlayer().components.inventory:IsItemEquipped(inst) then
	inst.components.container.canbeopened = false
	else
	inst.components.container.canbeopened = true
	end
	
	
	
    if inst.components.container:IsFull() then
	   
	    
	
    
       --Set up as projectile thrower instead of crummy bat
       inst:AddTag("projectile")
       inst.components.weapon:SetProjectile("gunpowder_projectile")
       inst:AddTag("blunderbuss")

       --Change ranges
       inst.components.weapon:SetRange(TUNING.BLUNDERBUSS_ATTACK_RANGE, TUNING.BLUNDERBUSS_HIT_RANGE)
       local damage = TUNING.GUNPOWDER_DAMAGE
       inst.components.weapon:SetDamage(damage)

       inst.override_bank = "swap_blunderbuss_loaded"

       --If equipped, change current equip overrides
       if inst.components.equippable and inst.components.equippable:IsEquipped() then
        local owner = inst.components.equippable.equipper
        owner.AnimState:OverrideSymbol("swap_object", inst.override_bank, "swap_blunderbuss")
        end

        --Change invo image.
        inst.components.inventoryitem:ChangeImageName("blunderbuss_loaded")
	
    elseif
	
       inst.components.container:IsEmpty() then
	   --Go back to crummy bat mode
       inst:RemoveTag("projectile")
       inst.components.weapon:SetProjectile(nil)
       inst:RemoveTag("blunderbuss")

       --Change ranges back to melee
       inst.components.weapon:SetRange(nil, nil)
       inst.components.weapon:SetDamage(TUNING.UNARMED_DAMAGE)

       --Change equip overrides
       inst.override_bank = "swap_blunderbuss"

       --If equipped, change current equip overrides
       if inst.components.equippable and inst.components.equippable:IsEquipped() then
        local owner = inst.components.equippable.equipper
        owner.AnimState:OverrideSymbol("swap_object", inst.override_bank, "swap_blunderbuss")
       end

       inst.components.inventoryitem:ChangeImageName("blunderbuss")
	
    end
end)

    

	
	inst.OnSave = onsave
    inst.OnLoad = onload

    return inst
end

local function onexplode(inst, scale)
	scale = scale or 1
	local pos = Vector3(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_explo")

	local explode = SpawnPrefab("explode_large")
	local ring = SpawnPrefab("explodering_fx")
	local pos = inst:GetPosition()

	ring.Transform:SetPosition(pos.x, pos.y, pos.z)
	ring.Transform:SetScale(scale, scale, scale)

	explode.Transform:SetPosition(pos.x, pos.y, pos.z)
	explode.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
	explode.AnimState:SetLightOverride(1)
	explode.Transform:SetScale(scale, scale, scale)
end


local function OnHit(inst, attacker, target, weapon)

    local impactfx = SpawnPrefab("impact")
    if impactfx and attacker then
        local follower = impactfx.entity:AddFollower()
        follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0)
        impactfx:FacePoint(attacker.Transform:GetWorldPosition())
    end
    inst:Remove()
end

local function projectile_fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
   	inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)

    anim:SetBank("amo01")
    anim:SetBuild("blunderbuss_ammo")
    anim:PlayAnimation("idle")

    inst:AddTag("projectile")
    --inst:AddTag("sharp")
    print("1234")
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(50)
    inst.components.projectile:SetOnHitFn(OnHit)	

    inst.persists = false

    return inst
end

return Prefab( "common/blunderbuss", fn, assets),
       Prefab( "common/gunpowder_projectile", projectile_fn, assets) 
